SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: 'pacman ghost blueberry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'RavasiAronson 5/16/2012 19:30'!
blueGhost

	^ ghost.! !

!PacManTest methodsFor: 'actors' stamp: 'RavasiAronson 5/20/2012 23:44'!
blueberry

	^ blueberry.! !

!PacManTest methodsFor: 'movements' stamp: 'RavasiAronson 5/16/2012 20:23'!
down

^0@(-1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'RavasiAronson 5/16/2012 20:29'!
ghostHouseDoorType

	^ GhostHouseDoorType new.! !

!PacManTest methodsFor: 'movements' stamp: 'RavasiAronson 5/16/2012 19:57'!
left

	^-1@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'RavasiAronson 5/16/2012 20:33'!
leftTransporterType

	^LeftTransporterType new! !

!PacManTest methodsFor: 'actors' stamp: 'RavasiAronson 5/16/2012 19:29'!
pacman

^ pacman.! !

!PacManTest methodsFor: 'movements' stamp: 'RavasiAronson 5/16/2012 19:57'!
right

^1@0.! !

!PacManTest methodsFor: 'initializing' stamp: 'RavasiAronson 5/20/2012 23:45'!
setUp 
	"initialize internal collaborators"

	pacman := Pacman new.
	ghost := Ghost new.
	blueberry := BlueBerry new.! !

!PacManTest methodsFor: 'construction block types' stamp: 'RavasiAronson 5/16/2012 20:03'!
spaceType

	^SpaceType new! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'RavasiAronson 5/16/2012 20:24'!
test03GhostMovesIntoSpaces
	
	self
		assert: self blueGhost position + (-1 @ 0)
		equals: (self spaceType nextPositionFor: self blueGhost going: self left).
	self
		assert: self blueGhost position + (1 @ 0)
		equals: (self spaceType nextPositionFor: self blueGhost going: self right).
	self assert: self blueGhost position + (0 @ 1) equals: (self spaceType nextPositionFor: self blueGhost going: self up).
	self
		assert: self blueGhost position + (0 @ -1)
		equals: (self spaceType nextPositionFor: self blueGhost going: self down)! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'RavasiAronson 5/16/2012 20:23'!
up

^0@1.! !

!PacManTest methodsFor: 'construction block types' stamp: 'RavasiAronson 5/16/2012 19:52'!
wallType

	^ WallType new.! !

Object subclass: #Actor
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'initializing' stamp: 'RavasiAronson 5/16/2012 20:53'!
initialize 

 self subclassResponsibility.! !

!Actor methodsFor: 'locating' stamp: 'RavasiAronson 5/16/2012 19:42'!
position
	"returns the actual position"

	^position.
	! !

Actor subclass: #BlueBerry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueBerry methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/20/2012 23:46'!
initialize 

	position := 3@3.! !

!BlueBerry methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 23:47'!
nextPositionFor: aBlockType going: aDirection 
	^ aBlockType nextPositionForBlueberry: self going: aDirection ! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/16/2012 19:41'!
initialize 
	"comment stating purpose of message"

	position := 1@1.! !

!Ghost methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 22:40'!
nextPositionFor: aBlockType going: aDirection
	^ aBlockType nextPositionForGhost: self going: aDirection.! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/16/2012 19:41'!
initialize 
	"comment stating purpose of message"

	position := 2@2.! !

!Pacman methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 22:44'!
nextPositionFor: aBlockType  going: aDirection 
	^ aBlockType nextPositionForPacman: self going: aDirection! !

Object subclass: #BlockType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlockType methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 19:49'!
nextPositionFor: actor going: direction 
	"comment stating purpose of message"

	self subclassResponsibility.! !

BlockType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 23:55'!
nextPositionFor: actor going: direction 

	^ actor nextPositionFor: self going: direction. ! !

!GhostHouseDoorType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 23:49'!
nextPositionForBlueberry: aBlueBerry going: aDirection 
	^ aBlueBerry position + aDirection.	! !

!GhostHouseDoorType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 22:43'!
nextPositionForGhost: aGhost going: aPoint 
	^ aGhost position + aPoint.! !

!GhostHouseDoorType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 22:45'!
nextPositionForPacman: aPacman going: aPoint 
	^ aPacman position ! !

BlockType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 23:55'!
nextPositionFor: anActor going: aDirection 

	^ anActor nextPositionFor: self going: aDirection. ! !

!LeftTransporterType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 23:51'!
nextPositionForBlueberry: aBlueBerry going: aPoint 
	^ 5@10! !

!LeftTransporterType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 22:48'!
nextPositionForGhost: aGhost going: aPoint 
	^ aGhost position ! !

!LeftTransporterType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 23:54'!
nextPositionForPacman: aPacman going: aPoint 
	^ 3@10! !

BlockType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 23:55'!
nextPositionFor: actor going: direction 

	^(actor position) + direction! !

BlockType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'moving' stamp: 'RavasiAronson 5/20/2012 23:55'!
nextPositionFor: actor going: direction

	^ actor position! !
